commit 36a1d386c779761e79f56ddfe2725feb7aa0bfe4
Author: Uros Bizjak <ubizjak@gmail.com>
Date:   Thu Nov 19 09:26:01 2020 +0100

    i386: Disable *<absneg:code><mode>2_i387_1 for TARGET_SSE_MATH modes
    
    This pattern interferes with *<absneg:code><mode>2_1 when TARGET_SSE_MATH
    modes are active. Combine pass is able to remove (use) RTXes and transforms
    *<absneg:code><mode>2_1 to *<absneg:code><mode>2_i387_1 where SSE
    alternatives are not available.
    
    2020-11-19  Uroš Bizjak  <ubizjak@gmail.com>
    
    gcc/
            PR target/97887
            * config/i386/i386.md (*<absneg:code><mode>2_i387_1):
            Disable for TARGET_SSE_MATH modes.
    
    gcc/testsuite/
            PR target/97887
            * gcc.target/i386/pr97887.c: New test.

diff --git a/gcc/testsuite/gcc.target/i386/pr97887.c b/gcc/testsuite/gcc.target/i386/pr97887.c
new file mode 100644
index 00000000000..b457f054bed
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr97887.c
@@ -0,0 +1,15 @@
+/* PR target/97887 */
+/* { dg-do compile } */
+/* { dg-options "-O2 -msse2 -mfpmath=sse" } */
+
+float f (float a)
+{
+  return -a / a;
+}
+
+double d (double a)
+{
+  return -a / a;
+}
+
+/* { dg-final { scan-assembler-not "fchs" } } */

